/***************************************************************************
                            CDATASection.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 CDATA sections are used to escape blocks of text containing
 characters that would otherwise be regarded as markup. The only
 delimiter that is recognized in a CDATA section is the "]]&gt;"
 string that ends the CDATA section. CDATA sections can not be
 nested. The primary purpose is for including material such as XML
 fragments, without needing to escape all the delimiters.

  The <code> DOMString </code> attribute of the <code> Text </code>
 node holds the text that is contained by the CDATA section. Note
 that this may contain characters that need to be escaped outside of
 CDATA sections and that, depending on the character encoding
 ("charset") chosen for serialization, it may be impossible to write
 out some characters as part of a CDATA section.

  The <code> CDATASection </code> interface inherits the <code>
 CharacterData </code> interface through the <code> Text </code>
 interface. Adjacent <code> CDATASections </code> nodes are not
 merged by use of the Element.normalize() method.

 
 @short *
 CDATA sections are used to escape blocks of text containing
 characters that would otherwise be regarded as markup.
*/
public class CDATASection extends Text  {
	protected CDATASection(Class dummy){super((Class) null);}

	private native void newCDATASection();
	public CDATASection() {
		super((Class) null);
		newCDATASection();
	}
	private native void newCDATASection( CDATASection other);
	public CDATASection( CDATASection other) {
		super((Class) null);
		newCDATASection( other);
	}
	private native void newCDATASection( DOMNode other);
	public CDATASection( DOMNode other) {
		super((Class) null);
		newCDATASection( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();
}
