/***************************************************************************
                            HTMLTableCellElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 The object used to represent the <code> TH </code> and <code> TD
 </code> elements. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#edef-TD">
 TD element definition </a> in HTML 4.0.

 
 @short *
 The object used to represent the <code> TH </code> and <code> TD
 </code> elements.
*/
public class HTMLTableCellElement extends HTMLElement  {
	protected HTMLTableCellElement(Class dummy){super((Class) null);}

	private native void newHTMLTableCellElement();
	public HTMLTableCellElement() {
		super((Class) null);
		newHTMLTableCellElement();
	}
	private native void newHTMLTableCellElement( HTMLTableCellElement other);
	public HTMLTableCellElement( HTMLTableCellElement other) {
		super((Class) null);
		newHTMLTableCellElement( other);
	}
	private native void newHTMLTableCellElement( DOMNode other);
	public HTMLTableCellElement( DOMNode other) {
		super((Class) null);
		newHTMLTableCellElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 The index of this cell in the row.

     
*/
	public native long cellIndex();

/** 
 see {@link cellIndex}

 This function is obsolete - the cellIndex property is actually supposed to be read-only
 (http://www.w3.org/DOM/updates/REC-DOM-Level-1-19981001-errata.html)
     
*/
	public native void setCellIndex( long arg1);

/** 
 Abbreviation for header cells. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-abbr">
 abbr attribute definition </a> in HTML 4.0.

     
*/
	public native String abbr();

/** 
 see {@link abbr}
     
*/
	public native void setAbbr( String arg1);

/** 
 Horizontal alignment of data in cell. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-align-TD">
 align attribute definition </a> in HTML 4.0.

     
*/
	public native String align();

/** 
 see {@link align}
     
*/
	public native void setAlign( String arg1);

/** 
 Names group of related headers. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-axis">
 axis attribute definition </a> in HTML 4.0.

     
*/
	public native String axis();

/** 
 see {@link axis}
     
*/
	public native void setAxis( String arg1);

/** 
 Cell background color. See the <a
 href="http://www.w3.org/TR/REC-html40/present/graphics.html#adef-bgcolor">
 bgcolor attribute definition </a> in HTML 4.0. This attribute
 is deprecated in HTML 4.0.

     
*/
	public native String bgColor();

/** 
 see {@link bgColor}
     
*/
	public native void setBgColor( String arg1);

/** 
 Alignment character for cells in a column. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-char">
 char attribute definition </a> in HTML 4.0.

     
*/
	public native String ch();

/** 
 see {@link ch}
     
*/
	public native void setCh( String arg1);

/** 
 Offset of alignment character. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-charoff">
 charoff attribute definition </a> in HTML 4.0.

     
*/
	public native String chOff();

/** 
 see {@link chOff}
     
*/
	public native void setChOff( String arg1);

/** 
 Number of columns spanned by cell. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-colspan">
 colspan attribute definition </a> in HTML 4.0.

     
*/
	public native long colSpan();

/** 
 see {@link colSpan}
     
*/
	public native void setColSpan( long arg1);

/** 
 List of <code> id </code> attribute values for header cells.
 See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-headers">
 headers attribute definition </a> in HTML 4.0.

     
*/
	public native String headers();

/** 
 see {@link headers}
     
*/
	public native void setHeaders( String arg1);

/** 
 Cell height. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-height-TH">
 height attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String height();

/** 
 see {@link height}
     
*/
	public native void setHeight( String arg1);

/** 
 Suppress word wrapping. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-nowrap">
 nowrap attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native boolean noWrap();

/** 
 see {@link noWrap}
     
*/
	public native void setNoWrap( boolean arg1);

/** 
 Number of rows spanned by cell. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-rowspan">
 rowspan attribute definition </a> in HTML 4.0.

     
*/
	public native long rowSpan();

/** 
 see {@link rowSpan}
     
*/
	public native void setRowSpan( long arg1);

/** 
 Scope covered by header cells. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-scope">
 scope attribute definition </a> in HTML 4.0.

     
*/
	public native String scope();

/** 
 see {@link scope}
     
*/
	public native void setScope( String arg1);

/** 
 Vertical alignment of data in cell. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-valign">
 valign attribute definition </a> in HTML 4.0.

     
*/
	public native String vAlign();

/** 
 see {@link vAlign}
     
*/
	public native void setVAlign( String arg1);

/** 
 Cell width. See the <a
 href="http://www.w3.org/TR/REC-html40/struct/tables.html#adef-width-TH">
 width attribute definition </a> in HTML 4.0. This attribute is
 deprecated in HTML 4.0.

     
*/
	public native String width();

/** 
 see {@link width}
     
*/
	public native void setWidth( String arg1);
}
