/***************************************************************************
                            HTMLTextAreaElement.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 Multi-line text field. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#edef-TEXTAREA">
 TEXTAREA element definition </a> in HTML 4.0.

 
 @short *
 Multi-line text field.
*/
public class HTMLTextAreaElement extends HTMLElement  {
	protected HTMLTextAreaElement(Class dummy){super((Class) null);}

	private native void newHTMLTextAreaElement();
	public HTMLTextAreaElement() {
		super((Class) null);
		newHTMLTextAreaElement();
	}
	private native void newHTMLTextAreaElement( HTMLTextAreaElement other);
	public HTMLTextAreaElement( HTMLTextAreaElement other) {
		super((Class) null);
		newHTMLTextAreaElement( other);
	}
	private native void newHTMLTextAreaElement( DOMNode other);
	public HTMLTextAreaElement( DOMNode other) {
		super((Class) null);
		newHTMLTextAreaElement( other);
	}
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 Stores the initial control value (i.e., the initial value of
 <code> value </code> ).

     
*/
	public native String defaultValue();

/** 
 see {@link defaultValue}
     
*/
	public native void setDefaultValue( String arg1);

/** 

     
*/
	public native HTMLFormElement form();

/** 
 A single character access key to give access to the form
 control. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-accesskey">
 accesskey attribute definition </a> in HTML 4.0.

     
*/
	public native String accessKey();

/** 
 see {@link accessKey}
     
*/
	public native void setAccessKey( String arg1);

/** 
 Width of control (in characters). See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-cols-TEXTAREA">
 cols attribute definition </a> in HTML 4.0.

     
*/
	public native long cols();

/** 
 see {@link cols}
     
*/
	public native void setCols( long arg1);

/** 
 The control is unavailable in this context. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-disabled">
 disabled attribute definition </a> in HTML 4.0.

     
*/
	public native boolean disabled();

/** 
 see {@link disabled}
     
*/
	public native void setDisabled( boolean arg1);

/** 
 Form control or object name when submitted with a form. See the
 <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-name-TEXTAREA">
 name attribute definition </a> in HTML 4.0.

     
*/
	public native String name();

/** 
 see {@link name}
     
*/
	public native void setName( String arg1);

/** 
 This control is read-only. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-readonly">
 readonly attribute definition </a> in HTML 4.0.

     
*/
	public native boolean readOnly();

/** 
 see {@link readOnly}
     
*/
	public native void setReadOnly( boolean arg1);

/** 
 Number of text rows. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-rows-TEXTAREA">
 rows attribute definition </a> in HTML 4.0.

     
*/
	public native long rows();

/** 
 see {@link rows}
     
*/
	public native void setRows( long arg1);

/** 
 Index that represents the element's position in the tabbing
 order. See the <a
 href="http://www.w3.org/TR/REC-html40/interact/forms.html#adef-tabindex">
 tabindex attribute definition </a> in HTML 4.0.

     
*/
	public native long tabIndex();

/** 
 see {@link tabIndex}
     
*/
	public native void setTabIndex( long arg1);

/** 
 The type of this form control.

     
*/
	public native String type();

/** 
 The current textual content of the multi-line text field. If
 the entirety of the data can not fit into a single wstring, the
 implementation may truncate the data.

     
*/
	public native String value();

/** 
 see {@link value}
     
*/
	public native void setValue( String arg1);

/** 
 Removes keyboard focus from this element.
     
*/
	public native void blur();

/** 
 Gives keyboard focus to this element.
     
*/
	public native void focus();

/** 
 Select the contents of the <code> TEXTAREA </code> .
     
*/
	public native void select();
}
