/***************************************************************************
                            KToolBarRadioGroup.java -  description
                             -------------------
    begin                : Fri Nov 15 11:45:52 2002
    copyright            : (C) 2000-2002 Lost Highway Ltd.
    email                : Richard_Dale@tipitina.demon.co.uk
    generated by         : duke@tipitina on Fri Nov 15 11:45:52 2002, using kalyptus 0.9.
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU Library General Public License as published by*
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
***************************************************************************/

package org.kde.koala;

import org.kde.qt.*;
import java.util.*;
import java.lang.Error;

/**

 KToolBarRadioGroup is class for group of radio butons in toolbar.
 Take toggle buttons which you already inserted into toolbar,
 create KToolBarRadioGroup instance and add them here.
 All buttons will emit signals toggled (bool) (or you can
 use sitgnal {@link #toggled} (int id) from toolbar). When one button is set
 down, all others are unset. All buttons emit signals - those who
 "go down" and those who "go up".

 See {@link KToolBarRadioGroupSignals} for signals emitted by KToolBarRadioGroup.

 

 @author Sven Radej <radej@kde.org>

 @short Class for group of radio butons in toolbar.
  
*/
public class KToolBarRadioGroup extends QObject  {
	protected KToolBarRadioGroup(Class dummy){super((Class) null);}

	private native void newKToolBarRadioGroup( KToolBar _parent, String _name);

/** 
 Constructor. Parent must be {@link KToolBar} .
   
*/
	public KToolBarRadioGroup( KToolBar _parent, String _name) {
		super((Class) null);
		newKToolBarRadioGroup( _parent, _name);
	}
	private native void newKToolBarRadioGroup( KToolBar _parent);
	public KToolBarRadioGroup( KToolBar _parent) {
		super((Class) null);
		newKToolBarRadioGroup( _parent);
	}

/** 
 Destructor.
   
*/
	protected native void finalize() throws InternalError;
	public native void dispose();
	public native boolean isDisposed();

/** 
 Adds button to group. Button cannot be unset by mouse clicks (you
 must press some other button tounset this one)
   
*/
	public native void addButton( int identifier);

/** 
 Removes button from group, making it again toggle button (i.e.
 You can unset it with mouse).
   
*/
	public native void removeButton( int identifier);

/** 
 Internal - nothing for you here.
   
*/
	public native void slotToggled( int arg1);
}
